# mypy-boto3-ds

[![PyPI - mypy-boto3-ds](https://img.shields.io/pypi/v/mypy-boto3-ds.svg?color=blue)](https://pypi.org/project/mypy-boto3-ds)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-ds.svg?color=blue)](https://pypi.org/project/mypy-boto3-ds)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-ds](#mypy-boto3-ds)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.DirectoryService 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/ds.html#DirectoryService) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.3](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-ds](#mypy-boto3-ds)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `DirectoryService` service.

```bash
python -m pip install boto3-stubs[ds]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_ds` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_ds import DirectoryServiceClient

# Now mypy can check if your code is valid.
client: DirectoryServiceClient = boto3.client("ds")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: DirectoryServiceClient = session.client("ds")



# Annotated paginators are included as well

import mypy_boto3_ds.paginator as ds_paginators

describe_directories_paginator: ds_paginators.DescribeDirectoriesPaginator = client.get_paginator("describe_directories")
describe_domain_controllers_paginator: ds_paginators.DescribeDomainControllersPaginator = client.get_paginator("describe_domain_controllers")
describe_shared_directories_paginator: ds_paginators.DescribeSharedDirectoriesPaginator = client.get_paginator("describe_shared_directories")
describe_snapshots_paginator: ds_paginators.DescribeSnapshotsPaginator = client.get_paginator("describe_snapshots")
describe_trusts_paginator: ds_paginators.DescribeTrustsPaginator = client.get_paginator("describe_trusts")
list_ip_routes_paginator: ds_paginators.ListIpRoutesPaginator = client.get_paginator("list_ip_routes")
list_log_subscriptions_paginator: ds_paginators.ListLogSubscriptionsPaginator = client.get_paginator("list_log_subscriptions")
list_schema_extensions_paginator: ds_paginators.ListSchemaExtensionsPaginator = client.get_paginator("list_schema_extensions")
list_tags_for_resource_paginator: ds_paginators.ListTagsForResourcePaginator = client.get_paginator("list_tags_for_resource")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_ds` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_ds as ds
from mypy_boto3_ds import DirectoryServiceClient

# with these
from mypy_boto3 import ds
from mypy_boto3.ds import DirectoryServiceClient
```